if Array.length Sys.argv < 2
     then raise ( Invalid_argument "Un u0 est demandé" ) ;;
let u0 = int_of_string Sys.argv.(1) ;;

open Enveloppe_convexe ;;

(*
Paramètre : n entier positif
Génère u_n tel que décrit dans l'énoncé
*)
let rec u ( n : int ) : int =
  if n == 0 then u0 else 37698 * ( u ( n - 1) ) mod 524287 ;;

(*
Paramètre = n : entier positif
Génère E_n tel que décrit dans l'énoncé
*)
let rec e ( n : int ) : ensemble =
  let ensemble = Array.make n ( 0, 0 ) in
  for i = 0 to n - 1 do
    ensemble.(i) <- ( u ( 2 * i ), u ( 2 * i + 1 ) )
  done ;
  ensemble ;;

let sprint_point ( p : point ) : string =
  let x, y = p in Printf.sprintf "( %i, %i )" x y ;;

Printf.printf "Question 3 : a) %i  b) %i  c) %i  \n"
  ( u 30 ) ( u 60 ) ( u 90 ) ;;

let e40 = e 40 ;;
let e270 = e 270 ;;
let e500 = e 500 ;;

let smax40 = sprint_point e40.( max_ensemble e40 ) in
let smax270 = sprint_point e270.( max_ensemble e270 ) in
let smax500 = sprint_point e500.( max_ensemble e500 ) in
Printf.printf
  "Question 4 : a) %s  b) %s  c) %s  \n" smax40 smax270 smax500 ;;

tri_rapide e40 ordre_lex ;;
tri_rapide e270 ordre_lex ;;
tri_rapide e500 ordre_lex ;;

let sp40 = sprint_point e40.(21) in
let sp270 = sprint_point e270.(144) in
let sp500 = sprint_point e500.(212) in
Printf.printf
  "Question 5 : a) %s  b) %s  c) %s \n" sp40 sp270 sp500;;

let f100 = enveloppe_convexe ( e 100 ) ;;
let f212 = enveloppe_convexe ( e 212 ) ;;
let f550 = enveloppe_convexe ( e 550 ) ;;

let car100 = cardinal_enveloppe f100 in
let car212 = cardinal_enveloppe f212 in
let car550 = cardinal_enveloppe f550 in
Printf.printf "Question 9 : a) %i  b) %i  c) %i \n" car100 car212 car550 ;;
